/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#include <string>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cmath>
#include "pointeur.h"

#define POINTEUR(T) pIntelligent<T>


#define NB_EMP 100




class Employe{
public:
  Employe(std::string nom, int age = 0 , double salaire = 1000.0 ){
    this->nom = new std::string(nom);
    this->age = new int(age);
    this->salaire = new double(salaire);
    
  }
  void setSalaire(double salaire){
    *this->salaire = salaire;
  }
  POINTEUR(double) getSalaire(){
    return salaire;
  }

  std::string toString(){
    std::ostringstream oss;
    oss << "Employe : "<< *nom << ", age : "<< *age <<", salaire : "<< *salaire;    
    return std::string(oss.str());
  }

private:
  POINTEUR(std::string) nom;
  POINTEUR(int) age;
  POINTEUR(double) salaire;
  
};

class Societe{
private:
  POINTEUR(Employe) employes[NB_EMP];
  POINTEUR(std::string) nom;
public:
  Societe( std::string nom){
    this->nom = new std::string(nom);
    std::ostringstream oss;
    for(int i = 0;i<NB_EMP;i++){
      if(i<10 or i%2 != 0){
	oss.str("");
	oss<<i;
	employes[i] = new Employe(nom + "toto" + oss.str(), (int) (rand()%40) +20, (double) (rand()%2000) + 1000.00);
      }else{
	//sinon reçois une reference aléatoire < i
	employes[i] = employes[(int)rand()%(i-1)];
      }
    }
  }

  void augmentation( double d){

    for(int i = 0; i<NB_EMP; i++){
      POINTEUR(double) s = employes[i]->getSalaire();
      employes[i]->setSalaire(*s * d);
    }
  }

  void print(){
    std::cout<<"Societe "<<*nom<<" :"<<std::endl;
    for(int i = 0;i<NB_EMP;i++){
      std::cout<< employes[i]->toString() <<std::endl;   
    }
  }

  void random(POINTEUR(Societe) s){
    for(int i = 0; i< NB_EMP; i++){
      employes[i] = s->employes[(int) rand()%NB_EMP];
    }
  }
};

class Groupe{
public:
  POINTEUR(Societe) p;
  
};

int main(){


  POINTEUR(Employe) toto = new Employe("toto",41,1500.0);
  std::cout<< toto->toString() <<std::endl;

  toto->setSalaire(2000.0);
  std::cout<< toto->toString() <<std::endl;

  POINTEUR(Societe) s1 = new Societe("s1") ;
  s1->print();

   POINTEUR(Societe) s2 = new Societe("s2") ;
  s2->print();
  
  s1->augmentation(1.3);

  s1->print();
  
  
  POINTEUR(Groupe) g1 = new Groupe;
  g1->p = s1;
  POINTEUR(Societe) s3 = s1;

  POINTEUR(Groupe) g2 = new Groupe;
  g2->p = g1->p;


  g1->p->random(g2->p);
  s1->print();

  return 0;
} 
